
package com.mycompany.ejbclient;

import com.mycompany.msgsenderandreceiver.data.TalkGroupDTO;
import com.mycompany.msgsenderandreceiver.SenderApi.MessageData;
import com.mycompany.msgsenderandreceiver.SenderApi.SenderApi;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;


public class EjbClient {
    
    
    public static void main(String [] args) {
        try {
            SenderApi api = lookupRemoteEJB();
            
            for (int i=0; i<5;i++) {
                api.sendMessage(createMessageObject());
            }
            
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
    
    private static SenderApi lookupRemoteEJB() throws NamingException {
        final Hashtable properties = new Hashtable();
        properties.put(Context.INITIAL_CONTEXT_FACTORY, "org.jboss.naming.remote.client.InitialContextFactory");
		properties.put(Context.PROVIDER_URL,"remote://10.0.0.7:4447");
		properties.put(Context.SECURITY_PRINCIPAL, "admin");
		properties.put(Context.SECURITY_CREDENTIALS, "jboss10)");
		properties.put(Context.URL_PKG_PREFIXES, "org.jboss.ejb.client.naming" );
		properties.put("jboss.naming.client.ejb.context", true);
        final Context context = new InitialContext(properties);
 
 
        final String appName = "";
        final String moduleName = "testapp";
        final String distinctName = "";
        final String beanName = "SenderImpl";
 
        final String viewClassName = SenderApi.class.getName();
        System.out.println("Looking EJB via JNDI ");
        System.out.println("ejb:" + appName + "/" + moduleName + "/" + distinctName + "/" + beanName + "!" + viewClassName);
 
        //return (SenderApi) context.lookup("ejb:" + appName + "/" + moduleName + "/" + distinctName + "/" + beanName + "!" + viewClassName);
 		return (SenderApi) context.lookup("testapp/SenderImpl!com.mycompany.msgsenderandreceiver.SenderApi.SenderApi");
 
 
    }
    
    public static Serializable createMessageObject() {
        
        List content = new ArrayList();

        
        for (int i = 0; i < 1500; i++) {
            TalkGroupDTO member = new TalkGroupDTO();
            /*member.setDbId(i);
            member.setSsi("100"+i);
            member.setMnemonic("test"+i);
            member.setName("test"+i);
            member.setComment("fdsfdsaas dfdsfsadfafasfsa");*/
            content.add(member);
        }
        
        Map map = new HashMap();
        map.put("key", content);
        
        MessageData data = new MessageData(1, "some text", new Date(), map);
        
        
        return (Serializable)content;
    }
}
