package com.mycompany.msgsenderandreceiver.data;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Objects;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.adapters.XmlJavaTypeAdapter;

public abstract class AbstractTalkGroupProfileDTO extends AuditableDto{
    @XmlTransient
    protected Integer dbId;
    protected String name;

    protected String id;
    
    @XmlJavaTypeAdapter(AbstractOrganisationDTO.OrganisationReferencingAdapter.class)
    protected OrganisationTetraDTO organisation;

    protected String comment;

    protected boolean prioritisePreviousUser;
    
    protected short groupCallPriority;

    protected short preEmptiveServiceRights;

    protected short talkingPartyIdentifier;
    
    protected short dispatcherCallRights;

    protected short emergencyCallType;

    protected short statusMessageDestination;
    
    protected short timeForDeliveryReport;
    
    protected short messageToCombinedGroup;
    
    protected boolean downloadChangesToRadios;

    protected boolean lastDispatcherNotification;
    
    protected short groupMode;

    protected Integer callSetupTimeLimit;

    protected Integer maxCallDuration;
    
    protected Integer maxSpeechItemDuration;
    
    protected Integer latencyTime;

    protected boolean lateEntry;
    
    protected Short leFpNumberOfMessages;
    
    protected Integer leFpMessageInterval;
    
    protected Integer leSpMessageInterval;
    
    protected boolean priorityScanning;
    
    protected Short psScope;

    protected Short psSetupPriority;

    protected Short psFpPriority;
    

    protected Integer psFpNumberOfMessages;
    
    protected Integer psFpMessageInterval;
    
    protected Integer psSpMessageInterval;

    protected short psDefaultScanningPriority;
    
    protected Integer radioPathRelease;
    
    protected Long callControlResourceRelease;

    protected short energyEconomy;
    
    protected short e2eeMode;
    
    protected short encryptionType;
    
    protected Short preEmptiveResourcePriority;
    
    protected boolean resourcePreEmptionAllowed;
    
    protected boolean preEmptionSpeechItemLevelsInUse;

    protected boolean dedicatedDataGroup;

    protected Short scchUse;

    public Long getCallControlResourceRelease() {
        return callControlResourceRelease;
    }

    public void setCallControlResourceRelease(Long callControlResourceRelease) {
        this.callControlResourceRelease = callControlResourceRelease;
    }

    public Integer getCallSetupTimeLimit() {
        return callSetupTimeLimit;
    }

    public void setCallSetupTimeLimit(Integer callSetupTimeLimit) {
        this.callSetupTimeLimit = callSetupTimeLimit;
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    public short getDispatcherCallRights() {
        return dispatcherCallRights;
    }

    public void setDispatcherCallRights(short dispatcherCallRights) {
        this.dispatcherCallRights = dispatcherCallRights;
    }

    @Override
    public List<Integer> getSearchParameters(){
        
        List <Integer> result = new ArrayList<Integer>();

        return result;
    }

    public boolean getDownloadChangesToRadios() {
        return downloadChangesToRadios;
    }

    public void setDownloadChangesToRadios(boolean downloadChangesToRadios) {
        this.downloadChangesToRadios = downloadChangesToRadios;
    }

    public short getE2eeMode() {
        return e2eeMode;
    }

    public void setE2eeMode(short e2eeMode) {
        this.e2eeMode = e2eeMode;
    }

    public short getEmergencyCallType() {
        return emergencyCallType;
    }

    public void setEmergencyCallType(short emergencyCallType) {
        this.emergencyCallType = emergencyCallType;
    }

    public short getEncryptionType() {
        return encryptionType;
    }

    public void setEncryptionType(short encryptionType) {
        this.encryptionType = encryptionType;
    }

    public short getEnergyEconomy() {
        return energyEconomy;
    }

    public void setEnergyEconomy(short energyEconomy) {
        this.energyEconomy = energyEconomy;
    }

    public short getGroupCallPriority() {
        return groupCallPriority;
    }

    public void setGroupCallPriority(short groupCallPriority) {
        this.groupCallPriority = groupCallPriority;
    }

    public short getGroupMode() {
        return groupMode;
    }

    public void setGroupMode(short groupMode) {
        this.groupMode = groupMode;
    }

    public boolean getLastDispatcherNotification() {
        return lastDispatcherNotification;
    }

    public void setLastDispatcherNotification(boolean lastDispatcherNotification) {
        this.lastDispatcherNotification = lastDispatcherNotification;
    }

    public boolean getLateEntry() {
        return lateEntry;
    }

    public void setLateEntry(boolean lateEntry) {
        this.lateEntry = lateEntry;
    }

    public Integer getLatencyTime() {
        return latencyTime;
    }

    public void setLatencyTime(Integer latencyTime) {
        this.latencyTime = latencyTime;
    }

    public Integer getLeFpMessageInterval() {
        return leFpMessageInterval;
    }

    public void setLeFpMessageInterval(Integer leFpMessageInterval) {
        this.leFpMessageInterval = leFpMessageInterval;
    }

    public Short getLeFpNumberOfMessages() {
        return leFpNumberOfMessages;
    }

    public void setLeFpNumberOfMessages(Short leFpNumberOfMessages) {
        this.leFpNumberOfMessages = leFpNumberOfMessages;
    }

    public Integer getLeSpMessageInterval() {
        return leSpMessageInterval;
    }

    public void setLeSpMessageInterval(Integer leSpMessageInterval) {
        this.leSpMessageInterval = leSpMessageInterval;
    }

    public Integer getMaxCallDuration() {
        return maxCallDuration;
    }

    public void setMaxCallDuration(Integer maxCallDuration) {
        this.maxCallDuration = maxCallDuration;
    }

    public Integer getMaxSpeechItemDuration() {
        return maxSpeechItemDuration;
    }

    public void setMaxSpeechItemDuration(Integer maxSpeechItemDuration) {
        this.maxSpeechItemDuration = maxSpeechItemDuration;
    }

    public short getMessageToCombinedGroup() {
        return messageToCombinedGroup;
    }

    public void setMessageToCombinedGroup(short messageToCombinedGroup) {
        this.messageToCombinedGroup = messageToCombinedGroup;
    }


    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getId() {
        return id;
    }

    public void setId(String talkGroupProfileId) {
        this.id = talkGroupProfileId;
    }

    public OrganisationTetraDTO getOrganisation() {
        return organisation;
    }

    public void setOrganisation(OrganisationTetraDTO organisation) {
        this.organisation = organisation;
    }

    public short getPreEmptiveServiceRights() {
        return preEmptiveServiceRights;
    }

    public void setPreEmptiveServiceRights(short preEmptiveServiceRights) {
        this.preEmptiveServiceRights = preEmptiveServiceRights;
    }

    public boolean getPrioritisePreviousUser() {
        return prioritisePreviousUser;
    }

    public void setPrioritisePreviousUser(boolean prioritisePreviousUser) {
        this.prioritisePreviousUser = prioritisePreviousUser;
    }

    public boolean getPriorityScanning() {
        return priorityScanning;
    }

    public void setPriorityScanning(boolean priorityScanning) {
        this.priorityScanning = priorityScanning;
    }

    public short getPsDefaultScanningPriority() {
        return psDefaultScanningPriority;
    }

    public void setPsDefaultScanningPriority(short psDefaultScanningPriority) {
        this.psDefaultScanningPriority = psDefaultScanningPriority;
    }

    public Integer getPsFpMessageInterval() {
        return psFpMessageInterval;
    }

    public void setPsFpMessageInterval(Integer psFpMessageInterval) {
        this.psFpMessageInterval = psFpMessageInterval;
    }

    public Integer getPsFpNumberOfMessages() {
        return psFpNumberOfMessages;
    }

    public void setPsFpNumberOfMessages(Integer psFpNumberOfMessages) {
        this.psFpNumberOfMessages = psFpNumberOfMessages;
    }

    public Short getPsFpPriority() {
        return psFpPriority;
    }

    public void setPsFpPriority(Short psFpPriority) {
        this.psFpPriority = psFpPriority;
    }

    public Short getPsScope() {
        return psScope;
    }

    public void setPsScope(Short psScope) {
        this.psScope = psScope;
    }

    public Short getPsSetupPriority() {
        return psSetupPriority;
    }

    public void setPsSetupPriority(Short psSetupPriority) {
        this.psSetupPriority = psSetupPriority;
    }

    public Integer getPsSpMessageInterval() {
        return psSpMessageInterval;
    }

    public void setPsSpMessageInterval(Integer psSpMessageInterval) {
        this.psSpMessageInterval = psSpMessageInterval;
    }

    public Integer getRadioPathRelease() {
        return radioPathRelease;
    }

    public void setRadioPathRelease(Integer radioPathRelease) {
        this.radioPathRelease = radioPathRelease;
    }

    public short getStatusMessageDestination() {
        return statusMessageDestination;
    }

    public void setStatusMessageDestination(short statusMessageDestination) {
        this.statusMessageDestination = statusMessageDestination;
    }

    @Override
    public Integer getDbId() {
        return dbId;
    }

    @Override
    public void setDbId(Integer dbId) {
        this.dbId = dbId;
    }

    public short getTalkingPartyIdentifier() {
        return talkingPartyIdentifier;
    }

    public void setTalkingPartyIdentifier(short talkingPartyIdentifier) {
        this.talkingPartyIdentifier = talkingPartyIdentifier;
    }

    public short getTimeForDeliveryReport() {
        return timeForDeliveryReport;
    }

    public void setTimeForDeliveryReport(short timeForDeliveryReport) {
        this.timeForDeliveryReport = timeForDeliveryReport;
    }

    public boolean isDedicatedDataGroup() {
        return dedicatedDataGroup;
    }

    public void setDedicatedDataGroup(boolean dedicatedDataGroup) {
        this.dedicatedDataGroup = dedicatedDataGroup;
    }

    public boolean isPreEmptionSpeechItemLevelsInUse() {
        return preEmptionSpeechItemLevelsInUse;
    }

    public void setPreEmptionSpeechItemLevelsInUse(boolean preEmptionSpeechItemLevelsInUse) {
        this.preEmptionSpeechItemLevelsInUse = preEmptionSpeechItemLevelsInUse;
    }

    public Short getPreEmptiveResourcePriority() {
        return preEmptiveResourcePriority;
    }

    public void setPreEmptiveResourcePriority(Short preEmptiveResourcePriority) {
        this.preEmptiveResourcePriority = preEmptiveResourcePriority;
    }

    public boolean isResourcePreEmptionAllowed() {
        return resourcePreEmptionAllowed;
    }

    public void setResourcePreEmptionAllowed(boolean resourcePreEmptionAllowed) {
        this.resourcePreEmptionAllowed = resourcePreEmptionAllowed;
    }

    public Short getScchUse() {
        return scchUse;
    }

    public void setScchUse(Short scchUse) {
        this.scchUse = scchUse;
    }
   

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final AbstractTalkGroupProfileDTO other = (AbstractTalkGroupProfileDTO) obj;
        if (!Objects.equals(this.dbId, other.dbId)) {
            return false;
        }
        return true;
    }
    

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 29 * hash + (this.dbId != null ? this.dbId.hashCode() : 0);
        return hash;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(name);
        sb.append(" (");
        sb.append(id);
        sb.append(")");
        return sb.toString();
    }
    
    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("dbId", "name", "id", "comment", "organisation"));
        return fields;
    }

    public String getOrgIdentifierAsString() {
        return (organisation!=null ? organisation.getOrganisationIdentifier() : "");
    }

}
