package com.mycompany.msgsenderandreceiver.data;

import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.Objects;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlValue;


@XmlAccessorType(XmlAccessType.FIELD)
public class ApnPoolDTO extends ComparableDTO
{
    
    private static final long serialVersionUID = 1L;
    
    @XmlValue
    private Integer apnPoolId;
    
    @XmlTransient
    private String apnPoolName;
    
    @XmlTransient
    private short status;
    
    @XmlTransient
    private Collection<ApnDTO> apnCollection;

    public Integer getApnPoolId() {
        return apnPoolId;
    }

    public void setApnPoolId(Integer apnPoolId) {
        this.apnPoolId = apnPoolId;
    }

    public String getApnPoolName() {
        return apnPoolName;
    }

    public void setApnPoolName(String apnPoolName) {
        this.apnPoolName = apnPoolName;
    }

    public short getStatus() {
        return status;
    }

    public void setStatus(short status) {
        this.status = status;
    }

    public Collection<ApnDTO> getApnCollection() {
        return apnCollection;
    }

    public void setApnCollection(Collection<ApnDTO> apnCollection) {
        this.apnCollection = apnCollection;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final ApnPoolDTO other = (ApnPoolDTO) obj;
        if (!Objects.equals(this.apnPoolId, other.apnPoolId)) {
            return false;
        }
        return true;
    }
    
    

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 17 * hash + (this.apnPoolId != null ? this.apnPoolId.hashCode() : 0);
        return hash;
    }
    

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(apnPoolName);
        sb.append(" (");
        sb.append(apnPoolId);
        sb.append(")");
        return sb.toString();
    }

    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("dbId", "status"));
        return fields;
    }
    
}
