package com.mycompany.msgsenderandreceiver.data;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;

@XmlAccessorType(XmlAccessType.FIELD)
public abstract class AuditableDto extends ComparableDTO  {

    private String creator;

    private Date creationTime;
    
    private String modifier;

    private Date modificationTime;
    
    protected Integer markingIndex;

    protected String markingName;
    
    @XmlTransient
    private String lockUsername;
    
    @XmlTransient
    private Date lockTime;

    @XmlTransient
    protected short status;

    @XmlTransient
    protected long additionalStatus;

    public AuditableDto() {
    }

    public AuditableDto(String creator, Date creationTime, String modifier, Date modificationTime, short status)
    {
        this.creator = creator;
        this.creationTime = creationTime != null ? new Date(creationTime.getTime()) : null;
        this.modifier = modifier;
        this.modificationTime = modificationTime != null ? new Date(modificationTime.getTime()) : null;
        this.status = status;
    }
    
    
    
    
    
    public Date getCreationTime() {
        return creationTime != null ? new Date(creationTime.getTime()) : null;
    }

    public String getCreator() {
        return creator;
    }

    public short getStatus() {
        return status;
    }

    public long getAdditionalStatus() {
        return additionalStatus;
    }

    public void setAdditionalStatus(long additionalStatus) {
        this.additionalStatus = additionalStatus;
    }

    public void setStatus(short status) {
        this.status = status;
    }

    public Date getModificationTime() {
        return modificationTime != null ? new Date(modificationTime.getTime()) : null;
    }

    public String getModifier() {
        return modifier;
    }

    public void setModifier(String modifier) {
        this.modifier = modifier;
    }

    public void setModificationTime(Date modificationTime) {
        this.modificationTime = modificationTime != null ? new Date(modificationTime.getTime()) : null;
        
    }

    public void setCreator(String creator) {
        this.creator = creator;
    }

    public void setCreationTime(Date creationTime) {
       this.creationTime = creationTime != null ? new Date(creationTime.getTime()) : null;
    }

    
    
    public Date getLockTime() {
        return lockTime != null ? new Date(lockTime.getTime()) : null;
    }

    public void setLockTime(Date lockTime) {
        this.lockTime = lockTime != null ? new Date(lockTime.getTime()) : null;
    }

    public String getLockUsername() {
        return lockUsername;
    }

    public void setLockUsername(String lockUsername) {
        this.lockUsername = lockUsername;
    }

    public Integer getMarkingIndex() {
        return markingIndex;
    }

    public void setMarkingIndex(Integer markingIndex) {
        this.markingIndex = markingIndex;
    }

    public void setMarkingName(String markingName) {
        this.markingName = markingName;
    }
    
    
    
    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("creator", "creationTime", "modifier", "modificationTime", "lockUsername", "lockTime", "status", "additionalStatus", "markingIndex", "markingName"));
        return fields;
    }

    @Override
    public List<String> getExcludedFields() {
        List<String> fields = super.getExcludedFields();
        fields.addAll(Arrays.asList("creator", "creationTime", "modifier", "modificationTime", "lockUsername", "lockTime", "status", "additionalStatus"));
        return fields;
    }
    
    public abstract Integer getDbId();
    
    public abstract void setDbId(Integer dbId);
    
    public abstract List<Integer> getSearchParameters();
    
    public abstract String getAttributeClassPrefix();
    
    public abstract AbstractOrganisationDTO getOrganisation();

}
