package com.mycompany.msgsenderandreceiver.data;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.adapters.XmlAdapter;




@XmlAccessorType(XmlAccessType.FIELD)
public class DistrictDTO extends AuditableDto {

    private static final long serialVersionUID = 1L;
       
    @XmlTransient
    private Integer dbId;

    private String id;

    private String name;
    
    private OrganisationTetraDTO organisation;

    private String comment;

    private Short wholeAreaCoreSiteInfo;
    
    private Collection<DistrictLocationAreaDTO> districtLocationAreaCollection;

    public DistrictDTO() {
    }

    public DistrictDTO(Integer dbId) {
        this.dbId = dbId;
    }

    public DistrictDTO(Integer dbId, String id, String name) {
        this.dbId = dbId;
        this.id = id;
        this.name = name;
    }

    @Override
    public Integer getDbId() {
        return dbId;
    }

    @Override
    public void setDbId(Integer dbId) {
        this.dbId = dbId;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Short getWholeAreaCoreSiteInfo() {
        return wholeAreaCoreSiteInfo;
    }

    public void setWholeAreaCoreSiteInfo(Short wholeAreaCoreSiteInfo) {
        this.wholeAreaCoreSiteInfo = wholeAreaCoreSiteInfo;
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    public Collection<DistrictLocationAreaDTO> getDistrictLocationAreaCollection() {
        return districtLocationAreaCollection;
    }

    public void setDistrictLocationAreaCollection(Collection<DistrictLocationAreaDTO> districtLocationAreaCollection) {
        this.districtLocationAreaCollection = districtLocationAreaCollection;
    }

    public OrganisationTetraDTO getOrganisation() {
        return organisation;
    }

    public void setOrganisation(OrganisationTetraDTO organisation) {
        this.organisation = organisation;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (dbId != null ? dbId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DistrictDTO)) {
            return false;
        }
        DistrictDTO other = (DistrictDTO) object;
        if ((this.dbId == null && other.dbId != null) || (this.dbId != null && !this.dbId.equals(other.dbId))) {
            return false;
        }
        return true;
    }

    
    public boolean isPerfectMatch(List<Integer> laIds)
    {
        return containsLocationAreas(laIds).size()==laIds.size() && districtLocationAreaCollection.size()==laIds.size();
    }
    
    public int howManyFound(List<Integer> laIds)
    {
        return containsLocationAreas(laIds).size();
    }
    
    public boolean notContainFalse(List<Integer> laIds)
    {
        return howManyFalseFound(laIds)==0;
    }
    
    
    public int howManyFalseFound(List<Integer> laIds)
    {
        return districtLocationAreaCollection.size() -  containsLocationAreas(laIds).size();
    }
    
    
    public boolean containsAllNeeded(List<Integer> laIds)
    {
        return containsLocationAreas(laIds).size()==laIds.size();
    }
    
    
    
    public boolean containsLocationAreas(DistrictDTO anotherDistrict)
    {
       
        
        Collection<DistrictLocationAreaDTO> dlaColl= anotherDistrict.getDistrictLocationAreaCollection();
        
        List<Integer> laIds =new ArrayList<Integer>();
        
        for(DistrictLocationAreaDTO dla:  dlaColl)
        {
            laIds.add(dla.getDxtLocationArea().getLocationAreaId());
        }
        
        return containsAllNeeded(laIds);
        
    }
    
    public List<Integer> containsLocationAreas(List<Integer> laIds)
    {
      // List<Integer> matches= new ArrayList<Integer>();
       Map<Integer,Integer>map = new HashMap<Integer,Integer>();
       
       
        for(Integer i : laIds)
        {
            boolean found = false;
            
            for(DistrictLocationAreaDTO dla:  districtLocationAreaCollection)
            {
                if(dla.getDxtLocationArea()!=null && dla.getDxtLocationArea().getLocationAreaId()==i)
                {
                    found=true;
                    //matches.add(i);
                    map.put(i, i);
                            
                }
                
            }    
            
        }
        return new ArrayList<Integer>(map.keySet());
    }
    
    @Override
    public String toString() {
        StringBuilder sb= new StringBuilder();
        sb.append(name);
        sb.append(" (");
        sb.append(id);
        sb.append(")");
        return sb.toString();        
    }



    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("dbId", "name", "comment", "organisation", "markingIndex"));
        return fields;
    }
    
    public String getOrgIdentifierAsString() {
        return organisation.getOrganisationIdentifier();
    }
    
    @Override
    public List<Integer> getSearchParameters(){
        
        List <Integer> result = new ArrayList<Integer>();

        return result;
    }


    @Override
    public String getAttributeClassPrefix() {
        return "TGD";
    }

    public static class DistrictReferencingAdapter extends XmlAdapter<String, DistrictDTO> {

        @Override
        public String marshal(DistrictDTO district) throws Exception {
            // return null;
            return (district == null) ? null : district.getId();
        }

        @Override
        public DistrictDTO unmarshal(String id) throws Exception {
            DistrictDTO dto = new DistrictDTO();
            dto.setId(id);
            return dto;
        }
    }  
    
}
