package com.mycompany.msgsenderandreceiver.data;

import java.util.Arrays;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.adapters.XmlAdapter;


@XmlAccessorType(XmlAccessType.FIELD)
public class DxtLocationAreaDTO extends ComparableDTO implements  Comparable<DxtLocationAreaDTO> {
    private static final long serialVersionUID = 1L;  
    
    @XmlTransient
    private Integer dbId;
    
    private int locationAreaId;
    
    @XmlTransient
    private String locationAreaName;
    
    @XmlTransient
    private short status;
    
    @XmlTransient
    private DxtDTO dxt;

    public Integer getDbId() {
        return dbId;
    }

    public void setDbId(Integer dbId) {
        this.dbId = dbId;
    }

    public int getLocationAreaId() {
        return locationAreaId;
    }

    public void setLocationAreaId(int locationAreaId) {
        this.locationAreaId = locationAreaId;
    }

    public String getLocationAreaName() {
        return locationAreaName;
    }

    public void setLocationAreaName(String locationAreaName) {
        this.locationAreaName = locationAreaName;
    }

    public short getStatus() {
        return status;
    }

    public void setStatus(short status) {
        this.status = status;
    }

    public DxtDTO getDxt() {
        return dxt;
    }

    public void setDxt(DxtDTO dxt) {
        this.dxt = dxt;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (dbId != null ? dbId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (!(obj instanceof DxtLocationAreaDTO)) {
            return false;
        }

        DxtLocationAreaDTO other = (DxtLocationAreaDTO) obj;
        
        if (this.locationAreaId != other.locationAreaId) {
            return false;
        }
        else if ((this.locationAreaName == null && other.locationAreaName != null) || (this.locationAreaName != null && !this.locationAreaName.equals(other.locationAreaName))) {
            return false;
        }
        else if ((this.dxt == null && other.dxt != null) || (this.dxt != null && !this.dxt.equals(other.dxt))) {
            return false;
        }
        else {
            return true;
        }
    }

    @Override
    public String toString() {
        StringBuilder sb= new StringBuilder();
        sb.append(locationAreaName);
        sb.append(" (");
        sb.append(locationAreaId);
        sb.append(")");
        return sb.toString();        
    }
    
    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("dbId", "status"));
        return fields;
    }

    @Override
    public int compareTo(DxtLocationAreaDTO t) 
    {
        
        return this.locationAreaId - t.getLocationAreaId();
    }
    
    public static class DxtLocationAreaReferencingAdapter extends XmlAdapter<String, DxtLocationAreaDTO> {

        @Override
        public String marshal(DxtLocationAreaDTO locationArea) throws Exception {
            return (locationArea == null) ? null : "" + locationArea.getLocationAreaId();
        }

        @Override
        public DxtLocationAreaDTO unmarshal(String locationArea) throws Exception {
            DxtLocationAreaDTO dto = new DxtLocationAreaDTO();
            dto.setLocationAreaId(Integer.parseInt(locationArea));
            return dto;
        }
    }  
    
}
