package com.mycompany.msgsenderandreceiver.data;

import java.util.Arrays;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;

@XmlAccessorType(XmlAccessType.FIELD)
public class OrganisationIpAddressRangeDTO extends ComparableDTO  {

    private static final long serialVersionUID = 1L;
    
    @XmlTransient
    private Integer dbId;
    
    private String lowerBoundary;
    
    private String upperBoundary;

    public OrganisationIpAddressRangeDTO() {
    }

    public OrganisationIpAddressRangeDTO(Integer dbId, String lowerBoundary, String upperBoundary) {
        this.dbId = dbId;
        this.lowerBoundary = lowerBoundary;
        this.upperBoundary = upperBoundary;
    }

    public Integer getDbId() {
        return dbId;
    }

    public void setDbId(Integer dbId) {
        this.dbId = dbId;
    }

    public String getLowerBoundary() {
        return lowerBoundary;
    }

    public void setLowerBoundary(String lowerBoundary) {
        this.lowerBoundary = lowerBoundary;
    }

    public String getUpperBoundary() {
        return upperBoundary;
    }

    public void setUpperBoundary(String upperBoundary) {
        this.upperBoundary = upperBoundary;
    }
    
    @Override
    public String toString()
    {
        return lowerBoundary+" - "+upperBoundary;
    }   

    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("dbId"));
        return fields;
    }
}
