
package com.mycompany.msgsenderandreceiver.data;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;

@XmlAccessorType(XmlAccessType.FIELD)
public class OrganisationTetraDTO extends AbstractOrganisationDTO {
    
    private static final long serialVersionUID = 1L;
    
    private String mnemonic;
    
    private DxtDTO dxt;  

    private Boolean preEmptiveRights;

    private String caDispatcher;

    private Integer eeGroupEsMode;
    
    private Integer eeGroupSpfNum;
    
    private Integer dualWatchAbsencePeriod;
    
    private Collection<OrganisationIpAddressRangeDTO> ipAddressRangeCollection;
    
    private Collection<ApnPoolDTO> apnPoolCollection;
    
    private Integer defaultApnIndex;
    
    private Integer subsClassDefaults;

    private Integer subsClassLocks;
    
    private Collection<OrganisationValueRangeDTO> valueRangeCollection;
    
    private Collection<OrganisationVisibilityDTO> organisationVisibilityCollection;
    
    private String emergencyTetraSsi;
    
    private String emergencyGatewaySsi;

    private String emergencyMsisdn;
    
    private Boolean mainOrgPreEmptionRights;

    // Not currently used anywhere, do not include in export file
    @XmlTransient
    private Short userGroupId = 0;
    
    private Collection<OrganisationParameterDTO> organisationParameterCollection;

    private Integer scchClass;

    private Boolean loadBasedScch;
    
    public OrganisationTetraDTO() {
    }

    public OrganisationTetraDTO(Integer[] orgBlockIdArray) {
        super(orgBlockIdArray);
    }

    public OrganisationTetraDTO(int organisationLevel1Id, int organisationLevel2Id, int organisationLevel3Id, int organisationLevel4Id, int organisationLevel5Id, int organisationLevel6Id) {
        super(organisationLevel1Id, organisationLevel2Id, organisationLevel3Id, organisationLevel4Id, organisationLevel5Id, organisationLevel6Id);
    }
    
    public OrganisationTetraDTO(String organisationIdentifier) {
        super(organisationIdentifier);
    }
    
    public OrganisationTetraDTO(String organisationIdentifier, boolean validate) throws Exception {
        super(organisationIdentifier, validate);
    }
    
    public String getMnemonic() {
        return mnemonic;
    }

    public void setMnemonic(String mnemonic) {
        this.mnemonic = mnemonic;
    }
    
    public Integer getSubsClassDefaults() {
        return subsClassDefaults;
    }

    public void setSubsClassDefaults(Integer subsClassDefaults) {
        this.subsClassDefaults = subsClassDefaults;
    }

    public Integer getSubsClassLocks() {
        return subsClassLocks;
    }

    public void setSubsClassLocks(Integer subsClassLocks) {
        this.subsClassLocks = subsClassLocks;
    }

    public Integer getEeGroupEsMode() {
        return eeGroupEsMode;
    }

    public void setEeGroupEsMode(Integer eeGroupEsMode) {
        this.eeGroupEsMode = eeGroupEsMode;
    }

    public Integer getEeGroupSpfNum() {
        return eeGroupSpfNum;
    }

    public void setEeGroupSpfNum(Integer eeGroupSpfNum) {
        this.eeGroupSpfNum = eeGroupSpfNum;
    }

    public Boolean getMainOrgPreEmptionRights() {
        return mainOrgPreEmptionRights;
    }

    public void setMainOrgPreEmptionRights(Boolean mainOrgPreEmptionRights) {
        this.mainOrgPreEmptionRights = mainOrgPreEmptionRights;
    }

    public Boolean getPreEmptiveRights() {
        return preEmptiveRights;
    }

    public void setPreEmptiveRights(Boolean preEmptiveRights) {
        this.preEmptiveRights = preEmptiveRights;
    }

    public String getCaDispatcher() {
        return caDispatcher;
    }

    public void setCaDispatcher(String caDispatcher) {
        this.caDispatcher = caDispatcher;
    }

    public Short getUserGroupId() {
        return userGroupId;
    }

    public void setUserGroupId(Short userGroupId) {
        this.userGroupId = userGroupId;
    }

    public Integer getDualWatchAbsencePeriod() {
        return dualWatchAbsencePeriod;
    }

    public void setDualWatchAbsencePeriod(Integer dualWatchAbsencePeriod) {
        this.dualWatchAbsencePeriod = dualWatchAbsencePeriod;
    }

    public Collection<OrganisationIpAddressRangeDTO> getIpAddressRangeCollection() {
        return ipAddressRangeCollection;
    }

    public void setIpAddressRangeCollection(Collection<OrganisationIpAddressRangeDTO> ipAddressRangeCollection) {
        this.ipAddressRangeCollection = ipAddressRangeCollection;
    }

    public Collection<OrganisationValueRangeDTO> getValueRangeCollection() {
        return valueRangeCollection;
    }

    public void setValueRangeCollection(Collection<OrganisationValueRangeDTO> valueRangeCollection) {
        this.valueRangeCollection = valueRangeCollection;
    }

    public Collection<ApnPoolDTO> getApnPoolCollection() {
        return apnPoolCollection;
    }

    public void setApnPoolCollection(Collection<ApnPoolDTO> apnPoolCollection) {
        this.apnPoolCollection = apnPoolCollection;
    }

    public DxtDTO getDxt() {
        return dxt;
    }

    public void setDxt(DxtDTO dxt) {
        this.dxt = dxt;
    }

    public Integer getDefaultApnIndex() {
        return defaultApnIndex;
    }

    public void setDefaultApnIndex(Integer defaultApnIndex) {
        this.defaultApnIndex = defaultApnIndex;
    }

    public String getEmergencyGatewaySsi() {
        return emergencyGatewaySsi;
    }

    public void setEmergencyGatewaySsi(String emergencyGatewaySsi) {
        this.emergencyGatewaySsi = emergencyGatewaySsi;
    }

    public String getEmergencyMsisdn() {
        return emergencyMsisdn;
    }

    public void setEmergencyMsisdn(String emergencyMsisdn) {
        this.emergencyMsisdn = emergencyMsisdn;
    }

    public String getEmergencyTetraSsi() {
        return emergencyTetraSsi;
    }

    public void setEmergencyTetraSsi(String emergencyTetraSsi) {
        this.emergencyTetraSsi = emergencyTetraSsi;
    }
    
    public Collection<OrganisationParameterDTO> getOrganisationParameterCollection() {
        return organisationParameterCollection;
    }

    public void setOrganisationParameterCollection(Collection<OrganisationParameterDTO> organisationParameterCollection) {
        this.organisationParameterCollection = organisationParameterCollection;
    }

    public Collection<OrganisationVisibilityDTO> getOrganisationVisibilityCollection() {
        return organisationVisibilityCollection;
    }

    public void setOrganisationVisibilityCollection(Collection<OrganisationVisibilityDTO> organisationVisibilityCollection) {
        this.organisationVisibilityCollection = organisationVisibilityCollection;
    }

    public Boolean getLoadBasedScch() {
        return loadBasedScch;
    }

    public void setLoadBasedScch(Boolean loadBasedScch) {
        this.loadBasedScch = loadBasedScch;
    }

    public boolean hasOrganisationVisibilities() {
        return (organisationVisibilityCollection != null && organisationVisibilityCollection.size() > 0);
    }

    public Integer getScchClass() {
        return (scchClass == null) ? 0 : scchClass;
    }

    public void setScchClass(Integer scchClass) {
        this.scchClass = scchClass;
    }
    
    public OrganisationValueRangeDTO getValueRange(int rangeType) {
        if (valueRangeCollection == null) {
            return null;
        }
        
        for (OrganisationValueRangeDTO range : valueRangeCollection) {
            if (range.getRangeType() == rangeType) {
                return range;
            }
        }
        
        return null;
    }
    
    public OrganisationParameterDTO getParameter(int parameterId) {
        if (organisationParameterCollection == null) {
            return null;
        }
        
        for (OrganisationParameterDTO param : organisationParameterCollection) {
            if (param.getParameter().getParameterId() == parameterId) {
                return param;
            }
        }
        
        return null;
    }
    
    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(mnemonic);
        sb.append(" (");
        sb.append(this.getOrganisationIdentifier());
        sb.append(")");
        
        return sb.toString();
    }
    
    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("dbId", "name", "comment", "markingIndex", "mainOrgPreEmptionRights"));
        return fields;
    }

    public boolean isViewCorFieldModified(){
//        System.out.println("isViewCorFieldModified "+getViewCorFields()+"/"+getModifiedFields());
        List<String> viewCOrFields = getViewCorFields();
        for (String viewCOrField : viewCOrFields) {
            if(getModifiedFields(false).contains(viewCOrField)){
//                System.out.println("true ("+viewCOrField+")");
                return true;
            }
            
        }
//        System.out.println("false");
        return false;
    }
    public List<String> getViewCorFields()
    {
        return Arrays.asList("organisationIdentifier", "mnemonic", "name");
    }    
    public List<String> getSummaryFields() {
        return Arrays.asList("organisationIdentifier", "mnemonic", "dxt");
    }
    
    public List<Integer> getSearchParameters(){
        List <Integer> result = new ArrayList<Integer>();

        return result;
    }
    
    @Override
    public String getAttributeClassPrefix() {
        if (getNodeLevel() == 1) {
            return "LEVEL1_ORG";
        } else {
            return "OB";
        }
    }
}
