package com.mycompany.msgsenderandreceiver.data;


import java.util.Arrays;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlTransient;


@XmlAccessorType(XmlAccessType.FIELD)
public class OrganisationValueRangeDTO extends ComparableDTO  {

    private static final long serialVersionUID = 1L;
    
    public static final int TYPE_ISSI = 1;
    public static final int TYPE_GSSI = 2;
    public static final int TYPE_MCC = 3;
    public static final int TYPE_MNC = 4;
    public static final int TYPE_FSSN_DOMAIN = 5;
    public static final int TYPE_MSISDN = 6;
    
    @XmlTransient
    private Integer dbId;
    
    @XmlAttribute(name="type")
    private int rangeType;
    
    @XmlAttribute(name="min")
    private String lowerBoundary;
    
    @XmlAttribute(name="max")
    private String upperBoundary;

    public OrganisationValueRangeDTO() {
    }

    public OrganisationValueRangeDTO(Integer dbId, int rangeType, String lowerBoundary, String upperBoundary) {
        this.dbId = dbId;
        this.rangeType = rangeType;
        this.lowerBoundary = lowerBoundary;
        this.upperBoundary = upperBoundary;
    }

    public Integer getDbId() {
        return dbId;
    }

    public void setDbId(Integer dbId) {
        this.dbId = dbId;
    }

    public int getRangeType() {
        return rangeType;
    }

    public void setRangeType(int rangeType) {
        this.rangeType = rangeType;
    }

    public String getLowerBoundary() {
        return lowerBoundary;
    }

    public void setLowerBoundary(String lowerBoundary) {
        this.lowerBoundary = lowerBoundary;
    }

    public String getUpperBoundary() {
        return upperBoundary;
    }

    public void setUpperBoundary(String upperBoundary) {
        this.upperBoundary = upperBoundary;
    }
    
    @Override
    public String toString() {
        return lowerBoundary + " - " + upperBoundary;
    }   

    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("dbId"));
        return fields;
    }
    

}
