package com.mycompany.msgsenderandreceiver.data;


import java.util.Arrays;
import java.util.List;
import javax.xml.bind.annotation.adapters.XmlAdapter;

public class ParameterDTO extends ComparableDTO 
{
    private static final long serialVersionUID = 1L;
    private Integer parameterId;
    private String parameterName;
    private int defaultValue;
    private String unit;
    private int minimum;
    private int maximum;

    public ParameterDTO() {
    }

    public Integer getParameterId() {
        return parameterId;
    }

    public void setParameterId(Integer parameterId) {
        this.parameterId = parameterId;
    }

    public String getParameterName() {
        return parameterName;
    }

    public void setParameterName(String parameterName) {
        this.parameterName = parameterName;
    }

    public int getDefaultValue() {
        return defaultValue;
    }

    public void setDefaultValue(int defaultValue) {
        this.defaultValue = defaultValue;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public int getMinimum() {
        return minimum;
    }

    public void setMinimum(int minimum) {
        this.minimum = minimum;
    }

    public int getMaximum() {
        return maximum;
    }

    public void setMaximum(int maximum) {
        this.maximum = maximum;
    }

    @Override
    public String toString() {
        StringBuilder sb= new StringBuilder();
        sb.append(parameterId);
        sb.append(" : ");
        sb.append(parameterName);
        sb.append(" : ");
        sb.append(defaultValue);
        sb.append(" : ");
        sb.append(unit);
        sb.append(" : ");
        sb.append(minimum);
        sb.append(" : ");
        sb.append(maximum);

        return sb.toString();
    }

    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("parameterName", "defaultValue", "unit", "minimum", "maximum"));
        return fields;
    }
    
    public static class ParameterReferencingAdapter extends XmlAdapter<String, ParameterDTO> {

        @Override
        public String marshal(ParameterDTO parameter) throws Exception {
            return (parameter == null) ? null : parameter.getParameterId().toString();
        }

        @Override
        public ParameterDTO unmarshal(String parameter) throws Exception {
            ParameterDTO dto = new ParameterDTO();
            dto.setParameterId(parameter == null ? null : Integer.parseInt(parameter));
            return dto;
        }
    }  
}
