package com.mycompany.msgsenderandreceiver.data;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.adapters.XmlAdapter;


@XmlAccessorType(XmlAccessType.FIELD)
public class TalkGroupDTO extends TimedDTO {

    private static final long serialVersionUID = 1L;
    
    @XmlTransient
    private Integer dbId;
    
    private String ssi;

    private String mnc;

    private String mcc;

    private OrganisationTetraDTO organisation;
    
    private String name;
    
    private DxtDTO dxt;
    
    private String mnemonic;

    private String comment;

    private TalkGroupProfileDTO profile;
    
    private boolean areaBlocking;

    private short areaType ;
    
    private short minPriority;

    private DistrictDTO privateDistrict;
    
    private Collection<DistrictDTO> districtCollection;
    
    private Collection<TalkGroupEntryRightDTO> entryRightCollection;

    private Date lifeTime;

    private short type;
   
    private Short reservationStatus;

    private Date reservationBeginTime;
    
    private Date reservationEndTime;

    private Date reservationUpdateTime;

    private String reserver;

    
    public TalkGroupDTO() {
    }

    public boolean getAreaBlocking() {
        return areaBlocking;
    }

    public void setAreaBlocking(boolean areaBlocking) {
        this.areaBlocking = areaBlocking;
    }

    public short getAreaType() {
        return areaType;
    }

    public void setAreaType(short areaType) {
        this.areaType = areaType;
    }
    
    public short getMinPriority() {
        return minPriority;
    }

    public void setMinPriority(short minPriority) {
        this.minPriority = minPriority;
    }

    public DxtDTO getDxt() {
        return dxt;
    }

    public void setDxt(DxtDTO dxt) {
        this.dxt = dxt;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getMnemonic() {
        return mnemonic;
    }

    public void setMnemonic(String mnemonic) {
        this.mnemonic = mnemonic;
    }

    public TalkGroupProfileDTO getProfile() {
        return profile;
    }

    public void setProfile(TalkGroupProfileDTO talkGroupProfile) {
        this.profile = talkGroupProfile;
    }
    
    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    public Date getLifeTime() {
        return lifeTime != null ? new Date(lifeTime.getTime()) : null;
    }

    public void setLifeTime(Date lifeTime) {
        this.lifeTime = lifeTime != null ? new Date(lifeTime.getTime()) : null;
    }

    public String getMcc() {
        return mcc;
    }

    public void setMcc(String mcc) {
        this.mcc = mcc;
    }

    public String getMnc() {
        return mnc;
    }

    public void setMnc(String mnc) {
        this.mnc = mnc;
    }
    
    public OrganisationTetraDTO getOrganisation() {
        return organisation;
    }

    public void setOrganisation(OrganisationTetraDTO organisation) {
        this.organisation = organisation;
    }

    public String getSsi() {
        return ssi;
    }

    public void setSsi(String ssi) {
        this.ssi = ssi;
    }
    
    // wrapper for summary view
    public int getGssi() {
        return Integer.parseInt(getSsi());
    }

    public Date getReservationBeginTime() {
        return reservationBeginTime != null ? new Date(reservationBeginTime.getTime()) : null;
    }

    public void setReservationBeginTime(Date reservationBeginTime) {
        this.reservationBeginTime = reservationBeginTime != null ? new Date(reservationBeginTime.getTime()) : null;
    }

    public Date getReservationEndTime() {
        return reservationEndTime != null ? new Date(reservationEndTime.getTime()) : null;
    }

    public void setReservationEndTime(Date reservationEndTime) {
        this.reservationEndTime = reservationEndTime != null ? new Date(reservationEndTime.getTime()) : null;
    }

    public Short getReservationStatus() {
        return reservationStatus;
    }

    public void setReservationStatus(Short reservationStatus) {
        this.reservationStatus = reservationStatus;
    }

    public Date getReservationUpdateTime() {
        return reservationUpdateTime != null ? new Date(reservationUpdateTime.getTime()) : null;
    }

    public void setReservationUpdateTime(Date reservationUpdateTime) {
        this.reservationUpdateTime = reservationUpdateTime != null ? new Date(reservationUpdateTime.getTime()) : null;
    }

    public String getReserver() {
        return reserver;
    }

    public void setReserver(String reserver) {
        this.reserver = reserver;
    }

    public short getType() {
        return type;
    }

    public void setType(short type) {
        this.type = type;
    }
    
    

    @Override
    public Integer getDbId() {
        return dbId;
    }

    @Override
    public void setDbId(Integer dbId) {
        this.dbId = dbId;
    }

    public DistrictDTO getPrivateDistrict() {
        preparePrivateDistrict();
        return privateDistrict;
    }

    public void preparePrivateDistrict() {
        if (privateDistrict == null) {
            privateDistrict = new DistrictDTO();
        }
        
        if (privateDistrict.getWholeAreaCoreSiteInfo() == null) {
            privateDistrict.setWholeAreaCoreSiteInfo((short) 0);
        }
        
        if (privateDistrict.getStatus() == 0) {
            privateDistrict.setStatus((short) 1);
        }
            


        if (privateDistrict.getName() == null) {
            privateDistrict.setName(mnemonic + "_" + privateDistrict.getId());
        }
        
        if (privateDistrict.getOrganisation() == null) {
            privateDistrict.setOrganisation(getOrganisation());
        }
    }

    public void setPrivateDistrict(DistrictDTO privateDistrict) {
        this.privateDistrict = privateDistrict;
    }

    public Collection<DistrictDTO> getDistrictCollection() {
        return districtCollection;
    }

    public void setDistrictCollection(Collection<DistrictDTO> districtCollection) {
        this.districtCollection = districtCollection;
    }

    public Collection<TalkGroupEntryRightDTO> getEntryRightCollection() {
        return entryRightCollection;
    }

    public void setEntryRightCollection(Collection<TalkGroupEntryRightDTO> EntryRightCollection) {
        this.entryRightCollection = EntryRightCollection;
    }

    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (dbId != null ? dbId.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof TalkGroupDTO)) {
            return false;
        }
        TalkGroupDTO other = (TalkGroupDTO) object;
        if ((this.dbId == null && other.dbId != null) || (this.dbId != null && !this.dbId.equals(other.dbId))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString()
    {
        StringBuilder sb = new StringBuilder();
        if (mnemonic != null && mnemonic.trim().length() > 0) {
            sb.append(mnemonic);
            sb.append(" (");
            sb.append(ssi);
            sb.append(")");
        } else {
            sb.append(ssi);
        }
        
        return sb.toString();
    }
    
    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("dbId", "name", "comment", "organisation", "talkGroupMember", "memberCollection",
                "type", "reservationStatus", "reservationBeginTime", "reservationEndTime", "reservationUpdateTime", "reserver", 
                "talkGroupLinkedGroupCollection"));
        return fields;
    }

    public String getOrgIdentifierAsString() {
        return organisation.getOrganisationIdentifier();
    }

    public List<Integer> getSearchParameters(){
        List <Integer> result = new ArrayList<Integer>();

        return result;
    }

    public boolean isViewCorFieldModified(){
//        System.out.println("isViewCorFieldModified "+getViewCorFields()+"/"+getModifiedFields());
        List<String> viewCOrFields = getViewCorFields();
        for (String viewCOrField : viewCOrFields) {
            if(getModifiedFields(false).contains(viewCOrField)){
//                System.out.println("true ("+viewCOrField+")");
                return true;
            }
            
        }
//        System.out.println("false");
        return false;
    }
    public List<String> getViewCorFields()
    {
        return Arrays.asList("mcc", "mnc", "ssi", "mnemonic", "name");
    }    



    @Override
    public String getAttributeClassPrefix() {
        return "TG";
    }

    public static class TalkGroupReferencingAdapter extends XmlAdapter<String, TalkGroupDTO> {

        @Override
        public String marshal(TalkGroupDTO group) throws Exception {
            return (group == null) ? null : group.getSsi();

        }

        @Override
        public TalkGroupDTO unmarshal(String ssi) throws Exception {
            TalkGroupDTO dto = new TalkGroupDTO();

            dto.setSsi(ssi);
            return dto;
        }

    }
 
}
