package com.mycompany.msgsenderandreceiver.data;

import java.util.Arrays;
import java.util.Date;
import java.util.List;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;


@XmlAccessorType(XmlAccessType.FIELD)
public abstract class TimedDTO extends AuditableDto {

    private Short currentLocation;

    private Short targetLocation;

    private Date locationActivationTime;

    private Date locationDeactivationTime;
    
    public Short getCurrentLocation() {
        return currentLocation;
    }

    public void setCurrentLocation(Short currentLocation) {
        this.currentLocation = currentLocation;
    }

    public Date getLocationActivationTime() {
        return locationActivationTime != null ? new Date(locationActivationTime.getTime()) : null;
    }

    public void setLocationActivationTime(Date locationActivationTime) {
        this.locationActivationTime = locationActivationTime != null ? new Date(locationActivationTime.getTime()) : null;
    }

    public Date getLocationDeactivationTime() {
        return locationDeactivationTime != null ? new Date(locationDeactivationTime.getTime()) : null;
    }

    public void setLocationDeactivationTime(Date locationDeactivationTime) {
        this.locationDeactivationTime = locationDeactivationTime != null ? new Date(locationDeactivationTime.getTime()) : null;
    }

    public Short getTargetLocation() {
        return targetLocation;
    }

    public void setTargetLocation(Short targetLocation) {
        this.targetLocation = targetLocation;
    }

    @Override
    public List<String> getCddExcludedFields() {
        List<String> fields = super.getCddExcludedFields();
        fields.addAll(Arrays.asList("currentLocation", "targetLocation", "locationActivationTime", "locationDeactivationTime"));
        return fields;
    }
}
